
\documentclass[tikz]{standalone}

\usepackage{tikz}
\usepackage{fontspec}
\usepackage{contour}

\setmainfont{Atkinson Hyperlegible}
\usetikzlibrary{shapes.geometric}
\usetikzlibrary{calc}
\usetikzlibrary{positioning}
\usetikzlibrary{arrows.meta}

\definecolor{one}{RGB}{237,28,36}
\definecolor{two}{RGB}{53,175,63}
\definecolor{three}{RGB}{247,146,16}
\definecolor{four}{RGB}{240,51,163}
\definecolor{five}{RGB}{9,148,206}
% \definecolor{six}{RGB}{149,107,37}
% \definecolor{seven}{RGB}{255,204,0}
% \definecolor{fifteen}{RGB}{247,171,99}
% \definecolor{sixteen}{RGB}{94,107,175}
% \definecolor{twentyone}{RGB}{227,0,11}
% \definecolor{twentytwo}{RGB}{253,195,0}
% \definecolor{twentythree}{RGB}{228,142,0}
% \definecolor{twentyfour}{RGB}{140,29,117}
% \definecolor{twentysix}{RGB}{243,155,154}

\input{../shapes_simple.tex}

\pgfdeclarelayer{bg}
\pgfdeclarelayer{lines}
\pgfdeclarelayer{stops}
\pgfdeclarelayer{labels}
\pgfdeclarelayer{legend}
\pgfsetlayers{bg,lines,stops,labels,main,legend}

\contourlength{.2ex}

\begin{document}

\begin{tikzpicture}[
    river/.style = {
      line width=0.5cm,
      cyan!50,
      rounded corners=0.5cm,
      {Triangle Cap}-{Triangle Cap},
    },
    railway line/.style = {
      color=gray,
      line width=0.075cm,
      rounded corners=0.5cm,
    },
    railway/.style = {
      railway line,
      {Latex[length=5mm]}-{Latex[length=5mm]},
    },
    stop/.style = {
      rounded corners=0.1cm, 
      line width=0.05cm,
      fill=white, 
      draw,
      shape=stop,
      anchor=center,
      minimum height=0.2cm,
    },
    stop1/.style = {
      stop,
      minimum width=0.2cm, 
    },
    stop2/.style = {
      stop,
      minimum width=0.4cm, 
    },
    stop3/.style = {
      stop,
      minimum width=0.6cm, 
    },
    stop4/.style = {
      stop,
      minimum width=0.8cm, 
    },
    line/.style = {
      line width=0.15cm,
      rounded corners=0.1cm,
    },
    label/.style = {
      font=\scriptsize,
    },
    line name/.style = {
      label, 
      color=white, 
      minimum width=1em, 
      minimum height=1em, 
      inner sep=0pt,
    },
  ]


  \begin{pgfonlayer}{stops}
    % Line 3 from Gundelfinger Straße to Rathaus im Stühlinger
    \node[stop1] (Gundelfinger Str) at (3,10) {};
    \node[stop1, below=0.3cm of Gundelfinger Str] (Glottertalstr) {};
    \node[stop1, below=0.3cm of Glottertalstr] (Berggasse) {};
    \node[stop1, below=0.3cm of Berggasse] (Reutebachgasse) {};
    \node[stop1, below=0.3cm of Reutebachgasse] (Tullastr) {};
    \node[stop2, below=0.4cm of Tullastr, anchor=two] (Hornusstr) {};
    \node[stop1, below=0.6cm of Hornusstr.two] (Okenstr) {};
    \node[stop1, below=0.3cm of Okenstr] (Hauptstr) {};
    \node[stop1, below=0.3cm of Hauptstr] (Tennenbacher Str) {};
    \node[stop2, below=0.4cm of Tennenbacher Str, anchor=two] (Europaplatz) {};
    \node[stop4, rotate=90] (Bertoldsbrunnen) at ($(Europaplatz.one)-(0.6,1.2)$) {};
    \node[stop4, rotate=90, left=1.2cm of Bertoldsbrunnen.one, anchor=one] (Stadttheater) {};
    \node[stop4, rotate=90, left=0.9cm of Stadttheater.one, anchor=one] (Hauptbahnhof) {};
    \node[stop4, rotate=90, left=0.9cm of Hauptbahnhof.one, anchor=one] (Eschholzstr) {};
    \node[stop4, rotate=90, left=0.9cm of Eschholzstr.one, anchor=one] (Rathaus im Stühlinger) {};
    \node[stop2, rotate=90, left=0.9cm of Rathaus im Stühlinger.one, anchor=one] (Runzmattenweg) {};

    % Line 2 from Hornusstraße to Bertoldsbrunnen
    \node[stop1] (Eugen-Martin-Str) at ($(Hornusstr.one)-(0.5,0.8)$) {};
    \node[stop1, below left=0.4cm of Eugen-Martin-Str] (Zollhallenplatz) {};
    \node[stop1, below left=0.4cm of Zollhallenplatz] (Hauptfriedhof) {};
    \node[stop1] (Friedrich-Ebert-Platz) at ($(Europaplatz.one)-(3.0,0)$) {};
    \node[stop2] (Robert-Koch-Str) at ($(Rathaus im Stühlinger.four)-(0.3,-0.5)$) {};

    % Line 5 from Europaplatz to Mattenstr
    \node[stop1] (Fahnenbergplatz) at ($(Europaplatz.one)-(1.5,0.5)$) {};
    \node[stop1, below=0.5cm of Stadttheater.one] (Erbprinzenstr) {};
    \node[stop1] (Mattenstr) at ($(Erbprinzenstr)-(0.9,1.2)$) {};

    % Line 4 from Bertoldsbrunnen and from Robert-Koch-Str
    \node[stop2, below=2.1cm of Europaplatz.one, anchor=two] (Holzmarkt) {};
    \node[stop1] (Killianstr) at ($(Robert-Koch-Str)-(0.6,-0.4)$) {};
    \node[stop1, left=0.3cm of Killianstr] (Berliner Allee) {};
    \node[stop1] (Elsässer Str) at ($(Berliner Allee)-(0.3,-0.6)$){};
    \node[stop1, above=0.3cm of Elsässer Str] (Technische Fakultät) {};
    \node[stop1] (Europa-Park-Stadium) at ($(Technische Fakultät)+(-0.3,0.6)$) {};
    \node[stop1, above left=0.3cm of Europa-Park-Stadium] (Messe) {};
    \node[stop2, below=0.8cm of Holzmarkt] (Johanneskirche) {};
    \node[stop1] (Reiterstr) at ($(Johanneskirche.one)-(0.3,0.6)$) {};
    \node[stop2, rotate=90] (Heinrich-von-Stephan-Str) at ($(Reiterstr)-(3.3,0.5)$) {};

    % Line 1 from Runzmattenweg and from Bertoldsbrunnen
    \node[stop1, left=0.5cm of Runzmattenweg.two] (Am Bischofskreuz) {};
    \node[stop1, left=0.5cm of Am Bischofskreuz] (Betzenhauser Torplatz) {};
    \node[stop1] (Paduaallee) at ($(Betzenhauser Torplatz)-(1.2,-0.3)$) {};
    \node[stop1, above left=0.3cm of Paduaallee] (Moosgrund) {};
    \node[stop1, above left=0.3cm of Moosgrund] (Diakoniekrankenhaus) {};
    \node[stop1, above left=0.3cm of Diakoniekrankenhaus] (Moosweiher) {};
    \node[stop1, right=1.2cm of Bertoldsbrunnen.two] (Oberlinden) {};
    \node[stop1] (Schwabentorbrücke) at ($(Oberlinden)+(1.5,-0.9)$) {};
    \node[stop1, right=0.3cm of Schwabentorbrücke] (Brauerei Ganter) {};
    \node[stop1, right=0.3cm of Brauerei Ganter] (Maria-Hilf-Kirche) {};
    \node[stop1, right=0.3cm of Maria-Hilf-Kirche] (Alter Messplatz) {};
    \node[stop1, right=0.3cm of Alter Messplatz] (Musikhochschule) {};
    \node[stop1, right=0.3cm of Musikhochschule] (Emil-Gött-Str) {};
    \node[stop1, right=0.3cm of Emil-Gött-Str] (Hasemannstr) {};
    \node[stop1, right=0.3cm of Hasemannstr] (Römerhof) {};
    \node[stop1, right=0.3cm of Römerhof] (Laßbergstr) {}; 

    % Line 2 from Johanneskirche
    \node[stop1, below=0.6cm of Johanneskirche.two] (Lorettostr) {};
    \node[stop1, below=0.3cm of Lorettostr] (Holbeinstr) {};
    \node[stop1, below=0.3cm of Holbeinstr] (Wonnhalde) {};
    \node[stop1] (Wiesenweg) at ($(Wonnhalde)+(0.3,-0.6)$){};
    \node[stop1, below right=0.3cm of Wiesenweg] (Klosterplatz) {};
    \node[stop1, below right=0.3cm of Klosterplatz] (Günterstal Dorfstr) {};

    % Line 5 from Heinrich-von-Stephan-Str to Lindenwäldle
    \node[stop1, left=0.7cm of Heinrich-von-Stephan-Str.two] (Pressehaus) {};
    \node[stop1, left=0.3cm of Pressehaus] (Haslach Bad) {};
    \node[stop1, left=0.3cm of Haslach Bad] (Scherrerplatz) {};
    \node[stop1, left=0.3cm of Scherrerplatz] (Dorfbrunnen) {};
    \node[stop1, left=0.3cm of Dorfbrunnen] (Krozinger Str) {};
    \node[stop2, rotate=90, left=0.5cm of Krozinger Str, anchor=one] (Am Lindenwäldle) {};
    \node[stop1, left=0.9cm of Am Lindenwäldle.one] (Geschwister-Scholl-Platz) {};
    \node[stop1, left=0.3cm of Geschwister-Scholl-Platz] (Maria-von-Rudloff-Platz) {};
    \node[stop1, left=0.3cm of Maria-von-Rudloff-Platz] (Bollerstaudenstr) {};

    % Line 3 from Runzmattenweg
    \node[stop1] (Bissierstr) at ($(Runzmattenweg.one)-(0.6,0.3)$) {};
    \node[stop1] (Rohrgraben) at ($(Bissierstr)-(0.9,1.2)$) {};
    \node[stop1, below=0.3cm of Rohrgraben] (Bugginger Str) {};
    \node[stop1, below left=0.6cm of Am Lindenwäldle.two] (VAG-Zentrum) {};
    \node[stop1, below=0.3cm of VAG-Zentrum] (Munzinger Str) {};

    % Line 4 from Heinrich-von-Stephan-Str
    \node[stop1] (Weddingenstr) at ($(Heinrich-von-Stephan-Str.one)-(0.3,0.8)$) {};
    \node[stop1, below=0.4cm of Weddingenstr] (Peter-Thumb-Str) {};
    \node[stop1, below left=0.5cm of Peter-Thumb-Str] (Paula-Modersohn-Platz) {};
    \node[stop1, left=0.3cm of Paula-Modersohn-Platz] (Vauban Mitte) {};
    \node[stop1, left=0.3cm of Vauban Mitte] (Innsbrucker Str) {};

  \end{pgfonlayer}

  \begin{pgfonlayer}{bg}
    % \draw[help lines, color=gray!10] (-10, -15) grid[step=0.1] (10, 10);
    % \draw[help lines, color=gray!50] (-10, -15) grid (10, 10);
    \draw[river] ($(Bissierstr)-(4.5,0.8)$)
      -- ($(Holzmarkt)-(0,0.5)$)
      -- ++(1,0)
      -- ++(1,1)
      -- ++(5,0)
    ;
  \end{pgfonlayer}

  \begin{pgfonlayer}{lines}
    \pgfmathparse{0.1*tan(45/2)}
    \let\offset\pgfmathresult

    \draw[railway] ($(Hornusstr.two)+(2.9,2.6)$) 
      node[label, left, anchor=south west] {Karlsruhe}
      -- ($(Hornusstr.two)-(0,0.4)$)
      -- ($(Hauptbahnhof)$)
      -- ++(0, -1)
      -- ($(Pressehaus)+(0.3,0.3)$) 
      -- ++(0,-4)
      node[label, below, anchor=north] {Basel};
    
    \draw[railway] ($(Moosweiher)-(1.5,-1.5)$)
      node[label, right, anchor=south west] {Breisach}
      -- ($(Moosweiher)$)
      -| ($(Hauptbahnhof)$)
      -- ++(0, -1)
      -- ($(Pressehaus)+(0.3,0.3)$) 
      -- ++(0, -1.7)
      -- ++(2.3, 0)
      -- ++(2.2,2.2)
      -- ++(3,0)
      node[label, right, anchor=west] {Villingen-Schwenningen}
    ;


    \draw[line, one]
    (Laßbergstr)
      -- (Römerhof)
      -- (Hasemannstr)
      -- (Emil-Gött-Str)
      -- (Musikhochschule)
      -- (Alter Messplatz)
      -- (Maria-Hilf-Kirche)
      -- (Brauerei Ganter)
      -- (Schwabentorbrücke)
      -- ++(-0.3,0)
      -- ($(Oberlinden)+(0.3,0)$)
      -- (Oberlinden)
      -- (Bertoldsbrunnen.two)
      -- (Stadttheater.two)
      -- (Hauptbahnhof.two)
      -- (Eschholzstr.two)
      -- (Rathaus im Stühlinger.two)
      -- (Runzmattenweg.two)
      -- (Am Bischofskreuz)
      -- (Betzenhauser Torplatz)
      -- ($(Paduaallee)+(0.3,-0.3)$)
      -- (Paduaallee)
      -- (Moosgrund)
      -- (Diakoniekrankenhaus)
      -- (Moosweiher)
    ;

    \draw[line, two]
      (Hornusstr.one)
      -- ++(0,-0.3)
      -- (Eugen-Martin-Str)
      -- (Zollhallenplatz)
      -- (Hauptfriedhof)
      -- ($(Hauptfriedhof)-(0.43,0.43)$)
      -- (Friedrich-Ebert-Platz)
      -| (Robert-Koch-Str.two)
      |- (Rathaus im Stühlinger.four)
      -- (Eschholzstr.four)
      -- (Hauptbahnhof.four)
      -- (Stadttheater.four)
      -- (Bertoldsbrunnen.four)
      {[rounded corners=0.3cm]
      -| (Holzmarkt.two)
      }
      -- (Johanneskirche.two)
      -- (Lorettostr)
      -- (Holbeinstr)
      -- (Wonnhalde)
      -- ++(0,-0.3)
      -- (Wiesenweg)
      -- (Klosterplatz)
      -- (Günterstal Dorfstr)
    ;

    \draw[line, three]
      (Gundelfinger Str)
      -- (Glottertalstr)
      -- (Berggasse)
      -- (Reutebachgasse)
      -- (Tullastr)
      -- (Hornusstr.two)
      -- (Okenstr)
      -- (Hauptstr)
      -- (Tennenbacher Str)
      -- (Europaplatz.two)
      {[rounded corners=0.3cm]
      |- (Bertoldsbrunnen.one)
      }
      -- (Stadttheater.one)
      -- (Hauptbahnhof.one)
      -- (Eschholzstr.one)
      -- (Rathaus im Stühlinger.one)
      -- (Runzmattenweg.one)
      -- ++(-0.3,0)
      -- (Bissierstr)
      -- ($(Rohrgraben)+(0,0.3)$)
      -- (Rohrgraben)
      -- (Bugginger Str)
      |- (Am Lindenwäldle.two)
      {[rounded corners=0.3cm]
      -| (VAG-Zentrum)
      }
      -- (Munzinger Str)
    ;

    \draw[line, four]
      (Innsbrucker Str)
      -- (Vauban Mitte)
      -- (Paula-Modersohn-Platz)
      -| (Peter-Thumb-Str)
      -- (Weddingenstr)
      |- (Heinrich-von-Stephan-Str.one)
      -- ($(Reiterstr)-(0.6,0.6)$)
      -- (Reiterstr)
      -- ++(0.3,0.3)
      -- (Johanneskirche.one)
      -- (Holzmarkt.one)
      |- (Bertoldsbrunnen.three)
      -- (Stadttheater.three)
      -- (Hauptbahnhof.three)
      -- (Eschholzstr.three)
      -- (Rathaus im Stühlinger.three)
      {[rounded corners=0.3cm]
      -| (Robert-Koch-Str.one)
      }
      |- (Killianstr)
      -- (Berliner Allee)
      -| (Elsässer Str)
      -- (Technische Fakultät)
      -- ++(0,0.3)
      -- (Europa-Park-Stadium)
      -- (Messe)
    ;

    \draw[line, five]
      (Europaplatz.one)
      |- (Fahnenbergplatz)
      -| (Stadttheater)
      -- (Erbprinzenstr)
      -- ++(0,-0.3)
      -- (Mattenstr)
      -- ($(Mattenstr)-(0.8,0.8)$)
      -- (Heinrich-von-Stephan-Str.two)
      -- (Pressehaus)
      -- (Haslach Bad)
      -- (Scherrerplatz)
      -- (Dorfbrunnen)
      -- (Krozinger Str)
      -- (Am Lindenwäldle.one)
      -- (Geschwister-Scholl-Platz)
      -- (Maria-von-Rudloff-Platz)
      -- (Bollerstaudenstr)
    ;

  \end{pgfonlayer}

  \begin{pgfonlayer}{labels}
    \node[font=\scriptsize, color=white] at ($(Holzmarkt)-(8,0.5)$) {Dreisam};
    \foreach\stop/\placement/\anchor/\rotate in {
      Hauptbahnhof/left/east/45,
      Eschholzstr/left/east/45,
      Rathaus im Stühlinger/left/east/45,
      Stadttheater/left/east/45,
      Bertoldsbrunnen/left/east/45,
      Robert-Koch-Str/right/west/0,
      Killianstr/above/west/45,
      Berliner Allee/above/west/45,
      Elsässer Str/left/east/0,
      Technische Fakultät/left/east/0,
      Europa-Park-Stadium/left/east/0,
      Messe/left/east/0,
      Europaplatz/right/west/0,
      Gundelfinger Str/right/west/0,
      Glottertalstr/right/west/0,
      Berggasse/right/west/0,
      Reutebachgasse/right/west/0,
      Tullastr/right/west/0,
      Hornusstr/right/west/0,
      Okenstr/right/west/0,
      Hauptstr/right/west/0,
      Tennenbacher Str/right/west/0,
      Fahnenbergplatz/above/west/45,
      Friedrich-Ebert-Platz/above/east/-45,
      Eugen-Martin-Str/above/east/-45,
      Zollhallenplatz/above/east/-45,
      Hauptfriedhof/above/east/-45,
      Holzmarkt/right/west/0,
      Johanneskirche/right/west/0,
      Lorettostr/right/west/0,
      Holbeinstr/right/west/0,
      Wonnhalde/right/west/0,
      Wiesenweg/right/west/0,
      Klosterplatz/right/west/0,
      Günterstal Dorfstr/right/west/0,
      Erbprinzenstr/left/east/45,
      Mattenstr/right/west/0,
      Reiterstr/left/east/0,
      Heinrich-von-Stephan-Str/left/north west/0,
      Pressehaus/below/east/90,
      Haslach Bad/below/east/90,
      Scherrerplatz/below/east/90,
      Dorfbrunnen/below/east/90,
      Krozinger Str/below/east/90,
      Am Lindenwäldle/left/east/90,
      Bissierstr/left/east/0,
      Rohrgraben/left/east/0,
      Bugginger Str/left/east/0,
      Runzmattenweg/right/east/-45,
      Geschwister-Scholl-Platz/below/east/45,
      Maria-von-Rudloff-Platz/below/east/45,
      Bollerstaudenstr/below/east/45,
      VAG-Zentrum/left/east/45,
      Munzinger Str/left/east/45,
      Weddingenstr/right/west/0,
      Peter-Thumb-Str/right/west/0,
      Paula-Modersohn-Platz/below/east/45,
      Vauban Mitte/below/east/45,
      Innsbrucker Str/below/east/45,
      Am Bischofskreuz/above/east/-45,
      Betzenhauser Torplatz/above/east/-45,
      Paduaallee/left/east/0,
      Moosgrund/left/east/0,
      Diakoniekrankenhaus/left/east/0,
      Moosweiher/left/east/0,
      Oberlinden/above/west/45,
      Schwabentorbrücke/above/west/45,
      Brauerei Ganter/above/west/45,
      Maria-Hilf-Kirche/above/west/45,
      Alter Messplatz/above/west/45,
      Musikhochschule/above/west/45,
      Emil-Gött-Str/above/west/45,
      Hasemannstr/above/west/45,
      Römerhof/above/west/45,
      Laßbergstr/above/west/45%
    } \node[label, \placement=0.05cm of \stop, rotate=\rotate, anchor=\anchor] {\contour{white}{\stop}};
    \node[line name, fill=four, above=0.2cm of Messe] {\bf 4};
    \node[line name, fill=three, left=0.2cm of Gundelfinger Str] {\bf 3};
    \node[line name, fill=two, left=0.2cm of Hornusstr] {\bf 2};
    \node[line name, fill=two, below=0.2cm of Günterstal Dorfstr] {\bf 2};
    \node[line name, fill=five, left=0.2cm of Europaplatz] {\bf 5};
    \node[line name, fill=five, left=0.2cm of Bollerstaudenstr] {\bf 5};
    \node[line name, fill=three, below=0.2cm of Munzinger Str] {\bf 3};
    \node[line name, fill=four, left=0.2cm of Innsbrucker Str] {\bf 4};
    \node[line name, fill=one, above=0.2cm of Moosweiher] {\bf 1};
    \node[line name, fill=one, right=0.2cm of Laßbergstr] {\bf 1};
  \end{pgfonlayer}

\end{tikzpicture}

\end{document}
% vim: nospell conceallevel=0
